#include <cstdio>
#include <cstdlib>

// Interval is [0..N)
// 0 <= l, r <= N
// [l, r) iff l < r
// [l, N) U [0, r) iff l > r
// Contestant function.
//
long long play(long long N);

static int cat_steps = 0;
static long long cat_N, cat_x;
static long long cat_flip;
static int cat_maxsteps;
// Methods available to contestant
//

bool isInside(long long l, long long r) {
    ++cat_steps;
    bool lie = 0;
    if (cat_steps >= cat_flip) {
        lie = 1;
    }

    if (l == r) {
        return false ^ lie;
    } else if (l < r) {
        return (l <= cat_x && cat_x < r) ^ lie;
    } else {
        return (l <= cat_x || cat_x < r) ^ lie;
    }
}

static void done(long long x) {
    if (x != cat_x) {
        printf("Wrong Answer\n");
    } else if (cat_steps > cat_maxsteps) {
        printf("Too many steps. Used: %d Available: %d\n", cat_steps, cat_maxsteps);
    } else {
        printf("OK with %d steps to guess %lld\n", cat_steps, cat_x);
    }
    exit(0);
}

int main() {
    if (scanf("%lld %d", &cat_N, &cat_maxsteps) != 2) {
        printf("Invalid input data!\n");
        return 0;
    }
    cat_x = rand() % cat_N;
    cat_flip = rand() % (cat_x + 1);

    done(play(cat_N));
    printf("No answer received\n");
    return 0;
}
