/*
ID: espr1t
TASK: MatrixSearch
KEYWORDS: Medium, Ad-hoc, Interviews, Linear Solution
*/

#include <cstdio>
FILE* in = stdin; FILE* out = stdout;

const int MAX = 1000;

int n, m;
int a[MAX][MAX];
int rows[MAX][MAX], cols[MAX][MAX];

bool find(int needle) {
    int row = 0, col = m - 1;
    int add = rows[row][col];

    while (row < n && col >= 0) {
        while (row + 1 < n && a[row + 1][col] + add + rows[row + 1][col] <= needle)
            add += rows[++row][col];
        while (col - 1 >= 0 && a[row][col - 1] + add - cols[row][col] >= needle)
            add -= cols[row][col--];
        if (a[row][col] + add == needle)
            return true;
        add -= cols[row][col--];
    }
    return false;
}

void increment(int srow, int scol, int val) {
    for (int col = scol; col < m; col++)
        rows[srow][col] += val;
    for (int row = srow; row < n; row++)
        cols[row][scol] += val;
}

int main(void) {
//    in = fopen("MatrixSearch.in", "rt");

    fscanf(in, "%d %d", &n, &m);
    for (int row = 0; row < n; row++)
        for (int col = 0; col < m; col++)
            fscanf(in, "%d", &a[row][col]);

    int numQueries;
    fscanf(in, "%d", &numQueries);
    for (int q = 0; q < numQueries; q++) {
        int type;
        fscanf(in, "%d", &type);
        if (type == 1) {
            int needle;
            fscanf(in, "%d", &needle);
            fprintf(out, "%c\n", find(needle) ? 'Y' : 'N');
        } else {
            int row, col, val;
            fscanf(in, "%d %d %d", &row, &col, &val);
            increment(row - 1, col - 1, val);
        }
    }
    return 0;
}
