/*
ID: espr1t
TASK: MatrixSearch
KEYWORDS: Medium, Ad-hoc, Interviews, Okayish solution
*/

#include <cstdio>
FILE* in = stdin; FILE* out = stdout;

const int MAX = 1001;

int n, m;
int a[MAX][MAX];
int tree[MAX][MAX];

void update(int x, int y, int val) {
    for (int x1 = x + 1; x1 < MAX; x1 += (x1 & -x1))
	    for (int y1 = y + 1; y1 < MAX; y1 += (y1 & -y1))
			tree[x1][y1] += val;
}

int query(int x, int y) {
	int ret = 0;
	for (int x1 = x + 1; x1 > 0; x1 -= (x1 & -x1))
	    for (int y1 = y + 1; y1 > 0; y1 -= (y1 & -y1))
	        ret += tree[x1][y1];
	return ret;
}

int getCell(int row, int col) {
    return a[row][col] + query(row, col);
}

bool find(int needle) {
    int row = 0, col = m - 1;
    while (row < n && col >= 0) {
        while (row + 1 < n && getCell(row + 1, col) <= needle)
            row++;
        while (col - 1 >= 0 && getCell(row, col - 1) >= needle)
            col--;
        if (getCell(row, col) == needle)
            return true;
        col--;
    }
    return false;
}

void increment(int srow, int scol, int val) {
    update(srow, scol, val);
}

int main(void) {
//    in = fopen("MatrixSearch.in", "rt");

    fscanf(in, "%d %d", &n, &m);
    for (int row = 0; row < n; row++)
        for (int col = 0; col < m; col++)
            fscanf(in, "%d", &a[row][col]);

    int numQueries;
    fscanf(in, "%d", &numQueries);
    for (int q = 0; q < numQueries; q++) {
        int type;
        fscanf(in, "%d", &type);
        if (type == 1) {
            int needle;
            fscanf(in, "%d", &needle);
            fprintf(out, "%c\n", find(needle) ? 'Y' : 'N');
        } else {
            int row, col, val;
            fscanf(in, "%d %d %d", &row, &col, &val);
            increment(row - 1, col - 1, val);
        }
    }

    return 0;
}
