/*
ID: espr1t
TASK: MatrixSearch
KEYWORDS: Medium, Ad-hoc, Interviews, Standard solution
*/

#include <cstdio>
FILE* in = stdin; FILE* out = stdout;

const int MAX = 1000;

int n, m;
int a[MAX][MAX];

bool find(int needle) {
    int row = 0, col = m - 1;
    while (row < n && col >= 0) {
        while (row + 1 < n && a[row + 1][col] <= needle)
            row++;
        while (col - 1 >= 0 && a[row][col - 1] >= needle)
            col--;
        if (a[row][col] == needle)
            return true;
        col--;
    }
    return false;
}

void increment(int srow, int scol, int val) {
    for (int row = srow; row < n; row++) {
        for (int col = scol; col < m; col++) {
            a[row][col] += val;
        }
    }
}

int main(void) {
//    in = fopen("MatrixSearch.in", "rt");

    fscanf(in, "%d %d", &n, &m);
    for (int row = 0; row < n; row++)
        for (int col = 0; col < m; col++)
            fscanf(in, "%d", &a[row][col]);

    int numQueries;
    fscanf(in, "%d", &numQueries);
    for (int q = 0; q < numQueries; q++) {
        int type;
        fscanf(in, "%d", &type);
        if (type == 1) {
            int needle;
            fscanf(in, "%d", &needle);
            fprintf(out, "%c\n", find(needle) ? 'Y' : 'N');
        } else {
            int row, col, val;
            fscanf(in, "%d %d %d", &row, &col, &val);
            increment(row - 1, col - 1, val);
        }
    }

    return 0;
}
